/***************************************************************************
* SPROEVAL.C#
*
* Developed by     : RAINBOW SYSTEMS
* Creation Date    : 21-3-2002              
* (C) Copyright 1991-2002 Rainbow Technologies, Inc. All rights reserved.
*
* Description : SentinelSuperPro Evaluation Program for WIN16/WIN32s/WIN64-XP in C-Sharp .NET plateform .
*
* Purpose     : To demostrate the SentinelSuperPro API for C languages
*               running under Windows.

****************************************************************************/
//Include name space
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;



namespace Sproeval
{
	

	/// <summary>
	/// To demostrate the SentinelSuperPro API for C#(C-Sharp) languages running under Windows.
	/// This is source file for main form . 
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		// Diffrent resource control declaration here
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.Button SetProtocol;
		private System.Windows.Forms.Button FormatPkt;
		private System.Windows.Forms.Button InitializeBtn;
		private System.Windows.Forms.Button SetContactSrvBtn;
		private System.Windows.Forms.Button FindFirstBtn;
		private System.Windows.Forms.Button FindNextBtn;
		private System.Windows.Forms.Button GetContactSrv;
		private System.Windows.Forms.Button HeartBeat;
		private System.Windows.Forms.Button ReadBtn;
		private System.Windows.Forms.Button XReadBtn;
		private System.Windows.Forms.Button WriteBtn;
		private System.Windows.Forms.Button OverwriteBtn;
		private System.Windows.Forms.Button QueryBtn;
		private System.Windows.Forms.Button ActivateBtn;
		private System.Windows.Forms.Button DecrementBtn;
		private System.Windows.Forms.Button VersionBtn;
		private System.Windows.Forms.Button GetHardLmt;
		private System.Windows.Forms.Button StatusBtn;
		private System.Windows.Forms.Button KeyInfo;
		private System.Windows.Forms.Button GetSubLicBtn;
		private System.Windows.Forms.Button ReleaseLicBtn;
		private System.Windows.Forms.Button EnumServer;
		private System.Windows.Forms.TextBox CellNumber;
		private System.Windows.Forms.TextBox AccessCode;
		private System.Windows.Forms.TextBox Input;
		private System.Windows.Forms.TextBox Output;
		private System.Windows.Forms.ComboBox ComboBoxProtocolFlag;
		private System.Windows.Forms.Button ViewBtn;
		private System.Windows.Forms.Button PasswordBtn;
		private System.Windows.Forms.Button ExitBtn;


		
		//global variable for key passwords
		public static bool Key_WritePW=false;
		public static bool Key_OWritePW=false;
		public static ushort WritePW=0;
		public static ushort OverWritePW1=0;
		public static ushort OverWritePW2=0;
		//global variables for activate passwords
		public static ushort ActivatePwrd1=0, ActivatePwrd2=0;
		//const size for validation
		public const ushort VALIDDATA_LENGTH =4;
		public const ushort CELLADDRESS_LENGTH =2;
		public const ushort MINIMUM_QUERYDATA_LENGTH =8;
	
		public const ushort MIN_ACCESSCODE_RANGE =0;
		public const ushort MAX_ACCESSCODE_RANGE =3;
		// For byte to string manipulation.
		private	System.Text.ASCIIEncoding AE = new System.Text.ASCIIEncoding();
		private System.Windows.Forms.ListBox StatusLine;
		private System.Windows.Forms.ComboBox ServerName;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.ListBox ViewList;
		
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
		
			InitializeComponent();

			
		}

		// Distroy Form resource at time of closing the form.
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
			
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.EnumServer = new System.Windows.Forms.Button();
			this.ViewBtn = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.ReleaseLicBtn = new System.Windows.Forms.Button();
			this.GetSubLicBtn = new System.Windows.Forms.Button();
			this.KeyInfo = new System.Windows.Forms.Button();
			this.StatusBtn = new System.Windows.Forms.Button();
			this.GetHardLmt = new System.Windows.Forms.Button();
			this.VersionBtn = new System.Windows.Forms.Button();
			this.DecrementBtn = new System.Windows.Forms.Button();
			this.ActivateBtn = new System.Windows.Forms.Button();
			this.QueryBtn = new System.Windows.Forms.Button();
			this.OverwriteBtn = new System.Windows.Forms.Button();
			this.WriteBtn = new System.Windows.Forms.Button();
			this.XReadBtn = new System.Windows.Forms.Button();
			this.ReadBtn = new System.Windows.Forms.Button();
			this.HeartBeat = new System.Windows.Forms.Button();
			this.GetContactSrv = new System.Windows.Forms.Button();
			this.FindNextBtn = new System.Windows.Forms.Button();
			this.FindFirstBtn = new System.Windows.Forms.Button();
			this.SetContactSrvBtn = new System.Windows.Forms.Button();
			this.InitializeBtn = new System.Windows.Forms.Button();
			this.FormatPkt = new System.Windows.Forms.Button();
			this.SetProtocol = new System.Windows.Forms.Button();
			this.Output = new System.Windows.Forms.TextBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.PasswordBtn = new System.Windows.Forms.Button();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.ExitBtn = new System.Windows.Forms.Button();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.ViewList = new System.Windows.Forms.ListBox();
			this.ComboBoxProtocolFlag = new System.Windows.Forms.ComboBox();
			this.AccessCode = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.Input = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.ServerName = new System.Windows.Forms.ComboBox();
			this.label9 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.CellNumber = new System.Windows.Forms.TextBox();
			this.StatusLine = new System.Windows.Forms.ListBox();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox5.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// EnumServer
			// 
			this.EnumServer.Location = new System.Drawing.Point(8, 192);
			this.EnumServer.Name = "EnumServer";
			this.EnumServer.Size = new System.Drawing.Size(110, 25);
			this.EnumServer.TabIndex = 21;
			this.EnumServer.Text = "&EnumSever";
			this.EnumServer.Click += new System.EventHandler(this.EnumServer_Click);
			// 
			// ViewBtn
			// 
			this.ViewBtn.Location = new System.Drawing.Point(8, 24);
			this.ViewBtn.Name = "ViewBtn";
			this.ViewBtn.Size = new System.Drawing.Size(110, 25);
			this.ViewBtn.TabIndex = 0;
			this.ViewBtn.Text = "Ke&yView";
			this.ViewBtn.Click += new System.EventHandler(this.ViewBtn_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.EnumServer,
																					this.ReleaseLicBtn,
																					this.GetSubLicBtn,
																					this.KeyInfo,
																					this.StatusBtn,
																					this.GetHardLmt,
																					this.VersionBtn,
																					this.DecrementBtn,
																					this.ActivateBtn,
																					this.QueryBtn,
																					this.OverwriteBtn,
																					this.WriteBtn,
																					this.XReadBtn,
																					this.ReadBtn,
																					this.HeartBeat,
																					this.GetContactSrv,
																					this.FindNextBtn,
																					this.FindFirstBtn,
																					this.SetContactSrvBtn,
																					this.InitializeBtn,
																					this.FormatPkt,
																					this.SetProtocol});
			this.groupBox1.Location = new System.Drawing.Point(8, 328);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(350, 233);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "SuperPro APIs";
			// 
			// ReleaseLicBtn
			// 
			this.ReleaseLicBtn.Location = new System.Drawing.Point(230, 168);
			this.ReleaseLicBtn.Name = "ReleaseLicBtn";
			this.ReleaseLicBtn.Size = new System.Drawing.Size(110, 25);
			this.ReleaseLicBtn.TabIndex = 20;
			this.ReleaseLicBtn.Text = "Re&leaseLicense";
			this.ReleaseLicBtn.Click += new System.EventHandler(this.ReleaseLicBtn_Click);
			// 
			// GetSubLicBtn
			// 
			this.GetSubLicBtn.Location = new System.Drawing.Point(119, 168);
			this.GetSubLicBtn.Name = "GetSubLicBtn";
			this.GetSubLicBtn.Size = new System.Drawing.Size(110, 25);
			this.GetSubLicBtn.TabIndex = 19;
			this.GetSubLicBtn.Text = "GetSu&bLicense";
			this.GetSubLicBtn.Click += new System.EventHandler(this.GetSubLicBtn_Click);
			// 
			// KeyInfo
			// 
			this.KeyInfo.Location = new System.Drawing.Point(8, 168);
			this.KeyInfo.Name = "KeyInfo";
			this.KeyInfo.Size = new System.Drawing.Size(110, 25);
			this.KeyInfo.TabIndex = 18;
			this.KeyInfo.Text = "Get&KeyInfo";
			this.KeyInfo.Click += new System.EventHandler(this.KeyInfo_Click);
			// 
			// StatusBtn
			// 
			this.StatusBtn.Location = new System.Drawing.Point(230, 144);
			this.StatusBtn.Name = "StatusBtn";
			this.StatusBtn.Size = new System.Drawing.Size(110, 25);
			this.StatusBtn.TabIndex = 17;
			this.StatusBtn.Text = "GetF&ullStatus";
			this.StatusBtn.Click += new System.EventHandler(this.StatusBtn_Click);
			// 
			// GetHardLmt
			// 
			this.GetHardLmt.Location = new System.Drawing.Point(119, 144);
			this.GetHardLmt.Name = "GetHardLmt";
			this.GetHardLmt.Size = new System.Drawing.Size(110, 25);
			this.GetHardLmt.TabIndex = 16;
			this.GetHardLmt.Text = "GetHardLi&mit";
			this.GetHardLmt.Click += new System.EventHandler(this.GetHardLmt_Click);
			// 
			// VersionBtn
			// 
			this.VersionBtn.Location = new System.Drawing.Point(8, 144);
			this.VersionBtn.Name = "VersionBtn";
			this.VersionBtn.Size = new System.Drawing.Size(110, 25);
			this.VersionBtn.TabIndex = 15;
			this.VersionBtn.Text = "Get&Version";
			this.VersionBtn.Click += new System.EventHandler(this.VersionBtn_Click);
			// 
			// DecrementBtn
			// 
			this.DecrementBtn.Location = new System.Drawing.Point(230, 120);
			this.DecrementBtn.Name = "DecrementBtn";
			this.DecrementBtn.Size = new System.Drawing.Size(110, 25);
			this.DecrementBtn.TabIndex = 14;
			this.DecrementBtn.Text = "&Decrement";
			this.DecrementBtn.Click += new System.EventHandler(this.DecrementBtn_Click);
			// 
			// ActivateBtn
			// 
			this.ActivateBtn.Location = new System.Drawing.Point(119, 120);
			this.ActivateBtn.Name = "ActivateBtn";
			this.ActivateBtn.Size = new System.Drawing.Size(110, 25);
			this.ActivateBtn.TabIndex = 13;
			this.ActivateBtn.Text = "&Activate";
			this.ActivateBtn.Click += new System.EventHandler(this.ActivateBtn_Click);
			// 
			// QueryBtn
			// 
			this.QueryBtn.Location = new System.Drawing.Point(8, 120);
			this.QueryBtn.Name = "QueryBtn";
			this.QueryBtn.Size = new System.Drawing.Size(110, 25);
			this.QueryBtn.TabIndex = 12;
			this.QueryBtn.Text = "&Query";
			this.QueryBtn.Click += new System.EventHandler(this.QueryBtn_Click);
			// 
			// OverwriteBtn
			// 
			this.OverwriteBtn.Location = new System.Drawing.Point(230, 96);
			this.OverwriteBtn.Name = "OverwriteBtn";
			this.OverwriteBtn.Size = new System.Drawing.Size(110, 25);
			this.OverwriteBtn.TabIndex = 11;
			this.OverwriteBtn.Text = "&Overwrite";
			this.OverwriteBtn.Click += new System.EventHandler(this.OverwriteBtn_Click);
			// 
			// WriteBtn
			// 
			this.WriteBtn.Location = new System.Drawing.Point(119, 96);
			this.WriteBtn.Name = "WriteBtn";
			this.WriteBtn.Size = new System.Drawing.Size(110, 25);
			this.WriteBtn.TabIndex = 10;
			this.WriteBtn.Text = "&Write";
			this.WriteBtn.Click += new System.EventHandler(this.WriteBtn_Click);
			// 
			// XReadBtn
			// 
			this.XReadBtn.Location = new System.Drawing.Point(8, 96);
			this.XReadBtn.Name = "XReadBtn";
			this.XReadBtn.Size = new System.Drawing.Size(110, 25);
			this.XReadBtn.TabIndex = 9;
			this.XReadBtn.Text = "E&xtendedRead";
			this.XReadBtn.Click += new System.EventHandler(this.XReadBtn_Click);
			// 
			// ReadBtn
			// 
			this.ReadBtn.Location = new System.Drawing.Point(230, 72);
			this.ReadBtn.Name = "ReadBtn";
			this.ReadBtn.Size = new System.Drawing.Size(110, 25);
			this.ReadBtn.TabIndex = 8;
			this.ReadBtn.Text = "&Read";
			this.ReadBtn.Click += new System.EventHandler(this.ReadBtn_Click);
			// 
			// HeartBeat
			// 
			this.HeartBeat.Location = new System.Drawing.Point(119, 72);
			this.HeartBeat.Name = "HeartBeat";
			this.HeartBeat.Size = new System.Drawing.Size(110, 25);
			this.HeartBeat.TabIndex = 7;
			this.HeartBeat.Text = "Set&HeartBeat";
			this.HeartBeat.Click += new System.EventHandler(this.HeartBeat_Click);
			// 
			// GetContactSrv
			// 
			this.GetContactSrv.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.GetContactSrv.Location = new System.Drawing.Point(8, 72);
			this.GetContactSrv.Name = "GetContactSrv";
			this.GetContactSrv.Size = new System.Drawing.Size(110, 25);
			this.GetContactSrv.TabIndex = 6;
			this.GetContactSrv.Text = "&GetContactServer";
			this.GetContactSrv.Click += new System.EventHandler(this.GetContactSrv_Click);
			// 
			// FindNextBtn
			// 
			this.FindNextBtn.Location = new System.Drawing.Point(230, 48);
			this.FindNextBtn.Name = "FindNextBtn";
			this.FindNextBtn.Size = new System.Drawing.Size(110, 25);
			this.FindNextBtn.TabIndex = 5;
			this.FindNextBtn.Text = "Find&NextUnit";
			this.FindNextBtn.Click += new System.EventHandler(this.FindNextBtn_Click);
			// 
			// FindFirstBtn
			// 
			this.FindFirstBtn.Location = new System.Drawing.Point(119, 48);
			this.FindFirstBtn.Name = "FindFirstBtn";
			this.FindFirstBtn.Size = new System.Drawing.Size(110, 25);
			this.FindFirstBtn.TabIndex = 4;
			this.FindFirstBtn.Text = "&FindFirstUnit";
			this.FindFirstBtn.Click += new System.EventHandler(this.FindFirstBtn_Click);
			// 
			// SetContactSrvBtn
			// 
			this.SetContactSrvBtn.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
			this.SetContactSrvBtn.Location = new System.Drawing.Point(8, 48);
			this.SetContactSrvBtn.Name = "SetContactSrvBtn";
			this.SetContactSrvBtn.Size = new System.Drawing.Size(110, 25);
			this.SetContactSrvBtn.TabIndex = 3;
			this.SetContactSrvBtn.Text = "Set&ContactServer";
			this.SetContactSrvBtn.Click += new System.EventHandler(this.SetContactSrvBtn_Click);
			// 
			// InitializeBtn
			// 
			this.InitializeBtn.Location = new System.Drawing.Point(119, 24);
			this.InitializeBtn.Name = "InitializeBtn";
			this.InitializeBtn.Size = new System.Drawing.Size(110, 25);
			this.InitializeBtn.TabIndex = 1;
			this.InitializeBtn.Text = "Initiali&ze";
			this.InitializeBtn.Click += new System.EventHandler(this.button3_Click);
			// 
			// FormatPkt
			// 
			this.FormatPkt.Location = new System.Drawing.Point(8, 24);
			this.FormatPkt.Name = "FormatPkt";
			this.FormatPkt.Size = new System.Drawing.Size(110, 25);
			this.FormatPkt.TabIndex = 0;
			this.FormatPkt.Text = "Format&Packet";
			this.FormatPkt.Click += new System.EventHandler(this.FormatPkt_Click);
			// 
			// SetProtocol
			// 
			this.SetProtocol.Location = new System.Drawing.Point(230, 24);
			this.SetProtocol.Name = "SetProtocol";
			this.SetProtocol.Size = new System.Drawing.Size(110, 25);
			this.SetProtocol.TabIndex = 2;
			this.SetProtocol.Text = "Se&tProtocol";
			this.SetProtocol.Click += new System.EventHandler(this.SetProtocol_Click);
			// 
			// Output
			// 
			this.Output.Location = new System.Drawing.Point(60, 83);
			this.Output.Name = "Output";
			this.Output.ReadOnly = true;
			this.Output.Size = new System.Drawing.Size(191, 20);
			this.Output.TabIndex = 3;
			this.Output.Text = "";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.PasswordBtn,
																					this.ViewBtn});
			this.groupBox3.Location = new System.Drawing.Point(632, 328);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(126, 91);
			this.groupBox3.TabIndex = 2;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Miscellaneous";
			// 
			// PasswordBtn
			// 
			this.PasswordBtn.Location = new System.Drawing.Point(8, 50);
			this.PasswordBtn.Name = "PasswordBtn";
			this.PasswordBtn.Size = new System.Drawing.Size(110, 25);
			this.PasswordBtn.TabIndex = 1;
			this.PasswordBtn.Text = "Pa&sswords";
			this.PasswordBtn.Click += new System.EventHandler(this.PasswordBtn_Click);
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.ExitBtn});
			this.groupBox4.Location = new System.Drawing.Point(632, 504);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(126, 58);
			this.groupBox4.TabIndex = 4;
			this.groupBox4.TabStop = false;
			// 
			// ExitBtn
			// 
			this.ExitBtn.Location = new System.Drawing.Point(8, 20);
			this.ExitBtn.Name = "ExitBtn";
			this.ExitBtn.Size = new System.Drawing.Size(110, 25);
			this.ExitBtn.TabIndex = 0;
			this.ExitBtn.Text = "Ex&it";
			this.ExitBtn.Click += new System.EventHandler(this.ExitBtn_Click);
			// 
			// groupBox5
			// 
			this.groupBox5.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.ViewList});
			this.groupBox5.Location = new System.Drawing.Point(64, 48);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(612, 276);
			this.groupBox5.TabIndex = 9;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "KeyView";
			// 
			// ViewList
			// 
			this.ViewList.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.ViewList.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ViewList.ItemHeight = 14;
			this.ViewList.Location = new System.Drawing.Point(8, 14);
			this.ViewList.Name = "ViewList";
			this.ViewList.Size = new System.Drawing.Size(596, 252);
			this.ViewList.TabIndex = 8;
			// 
			// ComboBoxProtocolFlag
			// 
			this.ComboBoxProtocolFlag.AllowDrop = true;
			this.ComboBoxProtocolFlag.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.ComboBoxProtocolFlag.DropDownWidth = 191;
			this.ComboBoxProtocolFlag.Items.AddRange(new object[] {
																	  "NSPRO_TCP_PROTOCOL ",
																	  "NSPRO_IPX_PROTOCOL ",
																	  "NSPRO_NETBEUI_PROTOCOL ",
																	  "NSPRO_SAP_PROTOCOL "});
			this.ComboBoxProtocolFlag.Location = new System.Drawing.Point(60, 166);
			this.ComboBoxProtocolFlag.MaxDropDownItems = 4;
			this.ComboBoxProtocolFlag.Name = "ComboBoxProtocolFlag";
			this.ComboBoxProtocolFlag.Size = new System.Drawing.Size(191, 21);
			this.ComboBoxProtocolFlag.TabIndex = 5;
			// 
			// AccessCode
			// 
			this.AccessCode.Location = new System.Drawing.Point(210, 25);
			this.AccessCode.MaxLength = 1;
			this.AccessCode.Name = "AccessCode";
			this.AccessCode.Size = new System.Drawing.Size(41, 20);
			this.AccessCode.TabIndex = 1;
			this.AccessCode.Text = "";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 59);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(30, 15);
			this.label5.TabIndex = 4;
			this.label5.Text = "Input";
			// 
			// Input
			// 
			this.Input.AcceptsReturn = true;
			this.Input.Location = new System.Drawing.Point(60, 54);
			this.Input.MaxLength = 120;
			this.Input.Name = "Input";
			this.Input.Size = new System.Drawing.Size(191, 20);
			this.Input.TabIndex = 2;
			this.Input.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 30);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(44, 15);
			this.label3.TabIndex = 0;
			this.label3.Text = "Cell No.";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.ServerName,
																					this.label9,
																					this.ComboBoxProtocolFlag,
																					this.label8,
																					this.label7,
																					this.Output,
																					this.label6,
																					this.Input,
																					this.label5,
																					this.AccessCode,
																					this.label4,
																					this.CellNumber,
																					this.label3,
																					this.StatusLine});
			this.groupBox2.Location = new System.Drawing.Point(366, 328);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(259, 233);
			this.groupBox2.TabIndex = 1;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Input/Output Information";
			// 
			// ServerName
			// 
			this.ServerName.DropDownWidth = 191;
			this.ServerName.ItemHeight = 13;
			this.ServerName.Items.AddRange(new object[] {
															"RNBO_STANDALONE",
															"RNBO_SPN_DRIVER",
															"RNBO_SPN_LOCAL",
															"RNBO_SPN_BROADCAST",
															"RNBO_SPN_ALL_MODES",
															"RNBO_SPN_SERVER_MODES",
															"NO-NET"});
			this.ServerName.Location = new System.Drawing.Point(60, 196);
			this.ServerName.Name = "ServerName";
			this.ServerName.Size = new System.Drawing.Size(191, 21);
			this.ServerName.TabIndex = 6;
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(8, 200);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(40, 15);
			this.label9.TabIndex = 12;
			this.label9.Text = "Server ";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(8, 166);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(48, 15);
			this.label8.TabIndex = 10;
			this.label8.Text = "Protocol";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(8, 127);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(40, 15);
			this.label7.TabIndex = 8;
			this.label7.Text = "Status";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 88);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(40, 15);
			this.label6.TabIndex = 6;
			this.label6.Text = "Output";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(126, 30);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(73, 15);
			this.label4.TabIndex = 2;
			this.label4.Text = "Access Code";
			// 
			// CellNumber
			// 
			this.CellNumber.Location = new System.Drawing.Point(60, 25);
			this.CellNumber.MaxLength = 2;
			this.CellNumber.Name = "CellNumber";
			this.CellNumber.Size = new System.Drawing.Size(41, 20);
			this.CellNumber.TabIndex = 0;
			this.CellNumber.Text = "";
			// 
			// StatusLine
			// 
			this.StatusLine.BackColor = System.Drawing.SystemColors.InactiveBorder;
			this.StatusLine.CausesValidation = false;
			this.StatusLine.Location = new System.Drawing.Point(60, 112);
			this.StatusLine.Name = "StatusLine";
			this.StatusLine.Size = new System.Drawing.Size(191, 43);
			this.StatusLine.TabIndex = 4;
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Bitmap)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(24, 16);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(32, 32);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(64, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(208, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "Sentinel SuperPro Evaluation Program.";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(64, 32);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(368, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "Copyright (C) 1991-2002 Rainbow Technologies Inc. All rights reserved.";
			// 
			// MainForm
			// 
			this.AutoScale = false;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(772, 591);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.groupBox5,
																		  this.groupBox4,
																		  this.groupBox3,
																		  this.groupBox2,
																		  this.groupBox1,
																		  this.label2,
																		  this.label1,
																		  this.pictureBox1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Sentinel SuperPro Evaluation Program";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.groupBox1.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox5.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			
			MainForm MainFormObj = new MainForm();
			
			MainFormObj.ShowDialog();
		}
	

		
		/**************************************************************************
		'* Procedure: Form1_Load
		'*
		'* Purpose  : perform some opertaion at the time of Main form load.
		'*
		' Descrip   :called Initial view function to display key view i  keyView list box
		'****************************************************************************/
		private void Form1_Load(object sender, System.EventArgs e)
		{
			uint status = 0;			
			try 
			{
				// call RNBOsproFormatPacket API at the time of Main form load
				status= Superpro.RNBOsproFormatPacket( Superpro.packet, Superpro.SPRO_APIPACKET_SIZE );		
				if (status !=0)
				{
					MessageBox.Show("Error During FormatPacket API call.","Application Error");
					Close();
				}
				InitialView();
				ComboBoxProtocolFlag.SelectedIndex=0;

			}
			catch
			{
				MessageBox.Show("Error During API call. Probabily SX32W.dll missing.","Application Error");
			}

		}

		/**************************************************************************
		'* Procedure: FormatPkt_Click
		'*
		'* Purpose  : called on FormatPacket button click
		'*
		' Descrip   :RNBOsproFormatPacket API call is here
		'****************************************************************************/
		private void FormatPkt_Click(object sender, System.EventArgs e)
		{
			uint status = 0;			
			
			ServerName.Text="";	
			ComboBoxProtocolFlag.SelectedText="";
			ComboBoxProtocolFlag.SelectedIndex=0;
			
			//**************RNBOsproFormatPacket API **********************/
			status= Superpro.RNBOsproFormatPacket( Superpro.packet, Superpro.SPRO_APIPACKET_SIZE );
			// if API successfull then
			if (status==0)
			{
				// clear all the input text box
				clearTextBox_succ("FormatPacket");
			}
			else
			{
				// Diplay API failure messafe with API return code.
				clearTextBox_fail("FormatPacket",status);
			}
		}

		/**************************************************************************
		'* Procedure: SetProtocol_Click
		'*
		'* Purpose  : called on Setprotocol button click
		'*
		' Descrip   :RNBOsproSetProtocol API call is here
		'****************************************************************************/
		private void SetProtocol_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;
			int protocolFlag=-1;
			//Get protocol selected element value from ComboBox
			protocolFlag=ComboBoxProtocolFlag.SelectedIndex;
			
			if (protocolFlag ==-1) // if protocol flag value is not selected
			{
				MessageBox.Show("Select a value for protocol to proceed.","SetProtocol",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			// assign valid constant value for protocol flag defined in Superpro.cs 
			switch(protocolFlag)
			{
				case 0 :
					protocolFlag = (int)PROTOCOL_FLAG.NSPRO_TCP_PROTOCOL;
					break;
				case 1 :
					protocolFlag = (int)PROTOCOL_FLAG.NSPRO_IPX_PROTOCOL;
					break;
				case 2 :
					protocolFlag = (int)PROTOCOL_FLAG.NSPRO_NETBEUI_PROTOCOL;
					break;
				case 3 :
					protocolFlag = (int)PROTOCOL_FLAG.NSPRO_SAP_PROTOCOL;
					break;
			}
			
			//**************RNBOsproSetProtocol API **********************/
			status = Superpro.RNBOsproSetProtocol( Superpro.packet,protocolFlag);
			// if API successfull
			if (status==0)
			{	
				// clear all the input text box
				clearTextBox_succ("SetProtocol");
			}
			else // if API failed then
			{
				// Diplay API failure messafe with API return code.
				clearTextBox_fail("SetProtocol",status);
			}
		}

		/**************************************************************************
		'* Procedure: SetContactSrvBtn_Click
		'*
		'* Purpose  : Called on SetContactSrv button click
		'*
		' Descrip   :RNBOsproSetContactServer API call is here
		'****************************************************************************/
		private void SetContactSrvBtn_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;
			string serverName=""; // string variable for Server value
			// Get Contact server string value entered by user
			serverName=ServerName.Text;
			// check Servername for length
			if(serverName.Trim().Length >63)
			{
				MessageBox.Show("ContactServer name length must not be exceeded 63.","SetContactServer",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			
			//**************RNBOsproSetContactServer API **********************/
			status = Superpro.RNBOsproSetContactServer( Superpro.packet, serverName);
			// If API successfull
			if (status==0)
			{	
				//clear all input text box on API success
				clearTextBox_succ("SetContactServer");
			}
			else
			{
				// Diplay API failure messafe with API return code.
				clearTextBox_fail("SetContactServer",status);
				
			}
		}

		/**************************************************************************
		'* Procedure: FindFirstBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
		'*
		'* Purpose  : Called on FindFirstUnit button click
		'*
		' Descrip   :RNBOsproFindFirstUnit API call is here
		'****************************************************************************/		
		private void FindFirstBtn_Click(object sender, System.EventArgs e)
		{
			int i_IsValid;
			ushort status = 0;			
			string sDevID="";// string variable for DevID
			ushort DevID =0 ;
			//Get input string for DevID entered by user
			sDevID=Input.Text;
			//Perform validation for DevID string value and convert into integer.
			i_IsValid = isValidData(sDevID.Trim(),VALIDDATA_LENGTH,ref DevID);
			if(i_IsValid==1) // if DevID is blank string
			{
				MessageBox.Show("Specify DeveloperID in input box to proceed.","FindFirstUnit",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==2)// If DevID is of Invalid length
			{
				MessageBox.Show("DeveloperID must be in hex with length not exceeding 4 digits.","FindFirstUnit",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==3)// If DevID string is not valid HexString
			{
				MessageBox.Show("DeveloperID must be in hex with length not exceeding 4 digits.","FindFirstUnit",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
					
			//**************RNBOsproFindFirstUnit API **********************/
			status= Superpro.RNBOsproFindFirstUnit( Superpro.packet, DevID );
			// If API successfull
			if (status==0)
			{	
				//clear all input text box on API success
				clearTextBox_succ("FindFirstUnit");				
			}
			else
			{
				// Diplay API failure messafe with API return code.
				clearTextBox_fail("FindFirstUnit",status);
			}
			return;
		}

		/**************************************************************************
		'* Procedure: FindNextBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
		'*
		'* Purpose  : Called on FindNextUnit button click
		'*
		' Descrip   :RNBOsproFindNextUnit API call is here
		'****************************************************************************/

		private void FindNextBtn_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;			
			
			//**************RNBOsproFindNextUnit API **********************/
			status= Superpro.RNBOsproFindNextUnit(Superpro.packet );
			//clear all input text box on API success
			if (status==0)
			{	
				//clear all input text box on API success
				clearTextBox_succ("FindNextUnit");
			}
			else
			{
				// Diplay API failure messafe with API return code.
				clearTextBox_fail("FindNextUnit",status);
			}
		}

		/**************************************************************************
		'* Procedure: GetContactSrv_Click
		'*
		'* Purpose  : Called on GetContactServer button click
		'*
		' Descrip   :RNBOsproGetContactServer API call is here
		'****************************************************************************/
		private void GetContactSrv_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;			
			byte[] serverName = new byte[Superpro.MAX_NAME_LEN];//For get contact server
			
			//**************RNBOsproGetContactServer API **********************/
			status= Superpro.RNBOsproGetContactServer( Superpro.packet, serverName,Superpro.MAX_NAME_LEN);
			//If API get successfull
			if (status==0)
			{	
				//Display contact server name in server name box
				Output.Text=AE.GetString(serverName).ToUpper();
				// clear all input text box on API success
				clearTextBox_succ("GetContactServer");
			}
			else
			{
				//blank server name box to clear previously diplayed server value
				Output.Text="";
				// Diplay API failure messafe with API return code.
				clearTextBox_fail("GetContactServer",status);
			}
		}

	/**************************************************************************
	'* Procedure: HeartBeat_Click
	'*
	'* Purpose  : Called on SetHeartBeat button click
	'*
	' Descrip   :RNBOsproSetHeartBeat API call is here
	'****************************************************************************/
		private void HeartBeat_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;			
			int heartBeat=0;
			string sHeartBeat="";
			//get heart beat value as string
			sHeartBeat=Input.Text;
			//if heart beat value is blank
			if (sHeartBeat.Trim()== "")
			{
				MessageBox.Show("Specify heartbeat value to proceed.","SetHeartBeat",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			
			//convert heart beat value from string to integer
			try
			{
				heartBeat=Convert.ToInt32(Input.Text,10);
			}
			catch
			{
				// if heartbeat string value is not valid integer string value
				MessageBox.Show("Heartbeat value must be an integer between 60 to 2592000. Enter -1 for infinite heartbeat.","SetHeartBeat",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			
			if((heartBeat ==Superpro.INFINITE_HEARTBEAT)||( heartBeat >=Superpro.MIN_HEARTBEAT && heartBeat <=Superpro.MAX_HEARTBEAT))
			{
				//**************RNBOsproSetHeartBeat API **********************/
				status = Superpro.RNBOsproSetHeartBeat(Superpro.packet, heartBeat );
				//if API successfull
				if (status==0)
				{	
					//clear all input box on API success		
					clearTextBox_succ("SetHeartBeat");
				}
				else
				{
					// Diplay API failure messafe with API return code.
					clearTextBox_fail("SetHeartBeat",status);
				}
			}
			// if heart beat value in not valid
			else
			{
				MessageBox.Show("Heartbeat value must be an integer between 60 to 2592000. Enter -1 for infinite heartbeat.","SetHeartBeat",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}

		}

		/**************************************************************************
		'* Procedure: Read_Click
		'*
		'* Purpose  : Called on Read button click
		'*
		' Descrip   :RNBOsproRead API call is here
		'****************************************************************************/
		private void ReadBtn_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;
			ushort cellAdd=0;
			ushort data=0;
			int i_IsValid=-1;
			string scellAdd="";
			
			// Get Cell address value as string enterd by user
			scellAdd=CellNumber.Text;
			//Perform validation for CellAddress string value and convert into integer.
			i_IsValid = isValidData(scellAdd.Trim(), CELLADDRESS_LENGTH,ref cellAdd);
			
			if(i_IsValid==1)//if celladdress value is blank 
			{
				MessageBox.Show("Specify Cell No. to proceed.","Read",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==2)//if cell address string value length is invalid
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","Read",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==3)//if celladdress string is in valid hex string
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","Read",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			
			//**************RNBOsproRead API **********************/
			status = Superpro.RNBOsproRead( Superpro.packet, cellAdd, ref data );
			// if API successfull
			if(status==0)
			{
				//clear all input box on API success		
				clearTextBox_succ("Read");
				//display read data
				try
				{
					//display read data
					Output.Text = Convert.ToString(data,16);
				}
				catch
				{
					MessageBox.Show("Invalid Hex data read","Read",MessageBoxButtons.OK,MessageBoxIcon.Error);
					return;
				}
			}
			else
			{
				//clear output text box
				Output.Text ="";
				// Diplay API failure messafe with API return code.
				clearTextBox_fail("Read",status);
				
			}

		}

		/**************************************************************************
		'* Procedure: XRead_Click
		'*
		'* Purpose  : Called on Extendedread button click
		'*
		' Descrip   :RNBOsproExtendedread API call is here
		'****************************************************************************/
		private void XReadBtn_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;
			ushort cellAdd=0;
			ushort data=0;
			byte accessCode=0;
			int i_IsValid=-1;
			string scellAdd="";
			
			// Get Cell address value as string enterd by user
			scellAdd=CellNumber.Text;
			//Perform validation for CellAddress string value and convert into integer.
			i_IsValid = isValidData(scellAdd, 2,ref cellAdd);
			if(i_IsValid==1)//if celladdress value is blank 
			{
				MessageBox.Show("Specify Cell No. to proceed.","ExtendedRead",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==2)//if cell address string value length is invalid
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","ExtendedRead",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==3)//if celladdress string is in valid hex string
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","ExtendedRead",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			
			//**************RNBOsproExtendedRead API **********************/
			status = Superpro.RNBOsproExtendedRead( Superpro.packet, cellAdd, ref data, ref accessCode );
			// if API successfull
			if(status==0)
			{
				//clear all input box on API success		
				clearTextBox_succ("ExtendedRead");
				
				
				//display read data
				try
				{
					//display read data and thier accesscode
					AccessCode.Text = Convert.ToString(accessCode,16);
					Output.Text = Convert.ToString(data,16);
				}
				catch
				{
					MessageBox.Show("Invalid Hex data read","ExtendedRead",MessageBoxButtons.OK,MessageBoxIcon.Error);
					return;
				}
			}
			else
			{	
				//clear output and accessCode text box
				AccessCode.Text="";
				Output.Text ="";
				// Display API failure messafe with API return code.
				clearTextBox_fail("ExtendedRead",status);
				
			}
		}

		/**************************************************************************
		'* Procedure: Write_Click
		'*
		'* Purpose  : Called on Write button click
		'*
		' Descrip   :RNBOsproWrite API call is here
		'****************************************************************************/
		private void WriteBtn_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;
			ushort cellAdd=0;
			ushort data=0;
			byte accessCode=0;
			int i_IsValid=-1,j_IsValid=-1;
			string scellAdd="";
			string sData="";
			string sAccessCode="";
			
			// Get Cell address value as string enterd by user
			scellAdd=CellNumber.Text;
			// Get data value as string enterd by user
			sData=Input.Text;
			// Get accessCode value as string enterd by user
			sAccessCode=AccessCode.Text;
			//Perform validation for CellAddress string value and convert into integer.
			i_IsValid = isValidData(scellAdd.Trim(), CELLADDRESS_LENGTH,ref cellAdd);
			if(i_IsValid==1)//if celladdress value is blank 
			{
				MessageBox.Show("Specify Cell No. to proceed.","Write",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==2)//if cell address string value length is invalid
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","Write",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==3)//if celladdress string is in valid hex string
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","Write",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			//Perform validation for data string value and convert into integer.
			j_IsValid = isValidData(sData.Trim(), VALIDDATA_LENGTH,ref data);
			if(j_IsValid==1)//if data value is blank 
			{
				MessageBox.Show("Specify data to be written in input box to proceed.","Write",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(j_IsValid==2)//if data string value length is invalid
			{
				MessageBox.Show("Data to be written must be a hex with length not exceeding 4 digit.","Write",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(j_IsValid==3)//if data string value length is invalid
			{
				MessageBox.Show("Data to be written must be a hex with length not exceeding 4 digit.","Write",MessageBoxButtons.OK,MessageBoxIcon.Error);
				
				return;
			}

			
			if(sAccessCode.Trim()=="")//if accesscode string is blank
			{
				MessageBox.Show("Specify an Access Code to proceed.","Write",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			try
			{
				//Convert accesscode from string to integer
				accessCode=Convert.ToByte(sAccessCode,10);
			}
			catch
			{
				//if access code value is not valid integer string
				MessageBox.Show("Access Code must be between 0 to 3.","Write",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if (accessCode <MIN_ACCESSCODE_RANGE || accessCode >MAX_ACCESSCODE_RANGE)
			{
				//if access code value is not valid in valid range defined for accesscode
				MessageBox.Show("Access Code must be between 0 to 3.","Write",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}

			// check for write password value
			if ((!Key_WritePW)&&(!Key_OWritePW))
			{
				// If write password value is blank or 0 then
				MessageBox.Show("Specify Write Password using Passwords button to proceed.","Write",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;

			}
			
			//**************RNBOsproWrite API **********************/
			status = Superpro.RNBOsproWrite( Superpro.packet, WritePW, cellAdd, data, accessCode );
			// if API successfull
			if(status==0)
			{
				//clear all input box on API success		
				clearTextBox_succ("Write");
				
			}
			else
			{
				// Diplay API failure messafe with API return code.
				clearTextBox_fail("Write",status);
			}
		}

		/**************************************************************************
		'* Procedure: Overwrite_Click
		'*
		'* Purpose  : Called on Overwrite button click
		'*
		' Descrip   :RNBOsproOverwrite API call is here
		'****************************************************************************/
		private void OverwriteBtn_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;
			ushort cellAdd=0;
			ushort data=0;
			byte accessCode=0;
			int i_IsValid=-1,j_IsValid=-1;
			string scellAdd="";
			string sData="";
			string sAccessCode="";
			
			// Get Cell address value as string enterd by user
			scellAdd=CellNumber.Text;
			// Get data value as string enterd by user
			sData=Input.Text;
			// Get accessCode value as string enterd by user
			sAccessCode=AccessCode.Text;
			//Perform validation for CellAddress string value and convert into integer.
			i_IsValid = isValidData(scellAdd.Trim(), CELLADDRESS_LENGTH,ref cellAdd);
			if(i_IsValid==1)//if celladdress value is blank 
			{
				MessageBox.Show("Specify Cell No. to proceed.","Overwrite",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==2)//if cell address string value length is invalid
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","Overwrite",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==3)//if celladdress string is in valid hex string
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","Overwrite",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			//Perform validation for data string value and convert into integer.
			j_IsValid = isValidData(sData.Trim(),VALIDDATA_LENGTH,ref data);
			if(j_IsValid==1)//if data value is blank 
			{
				MessageBox.Show("Specify data to be written in input box to proceed.","Overwrite",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(j_IsValid==2)//if data string value length is invalid
			{
				MessageBox.Show("Data to be written must be a hex with length not exceeding 4 digit.","Overwrite",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(j_IsValid==3)//if data string value length is invalid
			{
				MessageBox.Show("Data to be written must be a hex with length not exceeding 4 digit.","Overwrite",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}

			if(sAccessCode=="")//if accesscode string is blank
			{
				MessageBox.Show("Specify an Access Code to proceed.","Overwrite",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			try
			{
				//Convert accesscode from string to integer
				accessCode=Convert.ToByte(sAccessCode,10);
			}
			catch
			{
				//if access code value is not valid integer string
				MessageBox.Show("Access Code must be between 0 to 3.","Overwrite",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if (accessCode <MIN_ACCESSCODE_RANGE || accessCode >MAX_ACCESSCODE_RANGE)
			{
				//if access code value is not valid in valid range defined for accesscode
				MessageBox.Show("Access Code must be between 0 to 3.","Overwrite",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}

			// check for write and overwrite passwords value
			if (!Key_OWritePW)
			{
				// If  passwords value is blank or 0 then
				MessageBox.Show("Specify Write, Overwrite Passwords using Passwords button to proceed.","Overwrite",MessageBoxButtons.OK,MessageBoxIcon.Error);

			}
			
			//**************RNBOsproOverwrite API **********************/
			status = Superpro.RNBOsproOverwrite( Superpro.packet, WritePW,OverWritePW1 , OverWritePW2, cellAdd, data, accessCode );
			// if API successfull
			if(status==0)
			{
				//clear all input box on API success		
				clearTextBox_succ("Overwrite");
			}
			else
			{
				// Diplay API failure messafe with API return code.
				clearTextBox_fail("Overwrite",status);
				
			}

		}

		/**************************************************************************
		'* Procedure: Query_Click
		'*
		'* Purpose  : Called on Query button click
		'*
		' Descrip   :RNBOsproQuery API call is here
		'****************************************************************************/

		private void QueryBtn_Click(object sender, System.EventArgs e)
		{
			uint resp32 = 0;
			byte[] queryData;
			byte[] queryResp;
			ushort status = 0;
			ushort cellAdd=0;
			int i_IsValid=-1;
			string scellAdd="";
			string squeryData="";
			
			// Get Cell address value as string enterd by user
			scellAdd=CellNumber.Text;
			//Perform validation for CellAddress string value and convert into integer.
			i_IsValid = isValidData(scellAdd.Trim(),CELLADDRESS_LENGTH,ref cellAdd);
			if(i_IsValid==1)//if celladdress value is blank 
			{
				MessageBox.Show("Specify Cell No. to proceed.","Query",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==2)//if cell address string value length is invalid
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","Query",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==3)//if celladdress string is in valid hex string
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","Query",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			
			// Get Querydata value as string enterd by user
			squeryData=Input.Text;
			//Perform validation for CellAddress string value and convert into integer.
			i_IsValid=isValidQueryData(squeryData.Trim());
			if(i_IsValid==1)//if querydata value is blank 
			{
				MessageBox.Show("Specify a query string to proceed.","Query",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==2)//if querydara string value length is invalid
			{
				MessageBox.Show("Query string must be in hex.\n The length of the string must be even and between 8 to 112.","Query",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==3)//if query is in valid hex string
			{
				MessageBox.Show("Query string must be in hex.\n The length of the string must be even and between 8 to 112.","Query",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
				
			//aalocate array for input query and output response
			queryData = new byte[squeryData.Length/2];
			queryResp = new byte[squeryData.Length/2];
			//Convert query string in valid query API inputs as per all interface logic
			queryData=ConvertQueryData(squeryData);
			//**************RNBOsproQuery API **********************/
			status = Superpro.RNBOsproQuery( Superpro.packet, cellAdd, queryData,  queryResp, ref resp32, (ushort)(squeryData.Length/2));
			// if API successfull
			if(status==0)
			{
				//clear all input box on API success		
				clearTextBox_succ("Query");
				// display out respnse as hex string
				Output.Text = ConvertResponse(queryResp);
						
			}
			else
			{
				//clear output text box
				Output.Text = "";
				// Diplay API failure messafe with API return code.
				clearTextBox_fail("Query",status);
				
			}
				
		}

		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure: ActivateBtn_Click
		'*
		'* Purpose  : Called on Activate button click
		'*
		' Descrip   :RNBOsproActivate API call is here
		'****************************************************************************/
		private void ActivateBtn_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;
			ushort cellAdd=0;
			int i_IsValid=-1;
			string scellAdd="";
			
			// Get Cell address value as string enterd by user
			scellAdd=CellNumber.Text;
			//Perform validation for CellAddress string value and convert into integer.
			i_IsValid = isValidData(scellAdd.Trim(), CELLADDRESS_LENGTH,ref cellAdd);
			if(i_IsValid==1)//if celladdress value is blank 
			{
				MessageBox.Show("Specify Cell No. to proceed.","Activate",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==2)//if cell address string value length is invalid
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","Activate",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==3)//if celladdress string is in valid hex string
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","Activate",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			
			if ((!Key_WritePW)&&(!Key_OWritePW))//check for write password value
			{
				//if write password value is blank or 0
				MessageBox.Show("Specify Write Password using Passwords button to proceed.","Activate",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}

			// display Activate password form to seek activate passwords
			ActivateForm ActivateFormForm = new ActivateForm();
			//check for valid activate passwords vaues
			if(ActivateFormForm.ShowDialog() == DialogResult.OK)
			{
				
				//**************RNBOsproActivate API **********************/
				status = Superpro.RNBOsproActivate( Superpro.packet, WritePW, ActivatePwrd1, ActivatePwrd2, cellAdd );
				// if API successfull
				if(status==0)
				{
					//clear all input box on API success		
					clearTextBox_succ("Activate");
					
					
				}
				else
				{
					// Diplay API failure messafe with API return code.
					clearTextBox_fail("Activate",status);
				}
			}
		}

		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure: DecrementBtn_Click
		'*
		'* Purpose  : Called on Decrement button click
		'*
		' Descrip   :RNBOsproDecrement API call is here
		'****************************************************************************/
		private void DecrementBtn_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;
			ushort cellAdd=0;
			int i_IsValid=-1;
			string scellAdd="";
			
			// Get Cell address value as string enterd by user
			scellAdd=CellNumber.Text;
			//Perform validation for CellAddress string value and convert into integer.
			i_IsValid = isValidData(scellAdd.Trim(), CELLADDRESS_LENGTH,ref cellAdd);
			if(i_IsValid==1)//if celladdress value is blank 
			{
				MessageBox.Show("Specify Cell No. to proceed.","Decrement",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==2)//if cell address string value length is invalid
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","Decrement",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==3)//if celladdress string is in valid hex string
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","Decrement",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if ((!Key_WritePW)&&(!Key_OWritePW))//check for write password value
			{
				//if write password value is blank or 0
				MessageBox.Show("Specify Write Password using Passwords button to proceed.","Decrement",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}

			//**************RNBOsproDecrement API **********************/
			status = Superpro.RNBOsproDecrement( Superpro.packet, WritePW, cellAdd );
			// if API successfull
			if(status==0)
			{
				//clear all input box on API success		
				clearTextBox_succ("Decrement");
			}
			else
			{
				// Diplay API failure messafe with API return code.				
				clearTextBox_fail("Decrement",status);
			}

		}

		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure: VersionBtn_Click
		'*
		'* Purpose  : Called on GetVersion button click
		'*
		' Descrip   :RNBOsproGetVersion API call is here
		'****************************************************************************/
		private void VersionBtn_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;			
			byte maj = 0;
			byte min = 0;
			byte rev = 0;
			byte ostype = 0;

			
			//**************RNBOsproGetVersion API **********************/
			status= Superpro.RNBOsproGetVersion( Superpro.packet, ref maj, ref min, ref rev, ref ostype );
			// if API successfull
			if (status==0)
			{	
				string driverType="";
				// assign OS type string value
				switch(ostype)
				{
					case 5:
						driverType=ostype + " (Windows NT system driver)";
						break;
					case 7:
						driverType=ostype + " (Windows 95 system driver)";
						break;
					case 8:
						driverType=ostype + " (Novell system driver)";
						break;
					case 10:
						driverType=ostype + " (Unknown driver type)";
						break;
				}
				//display version info value
				MessageBox.Show("Major Version : "+ Convert.ToString(maj)+ "," + "Minor Version : " + Convert.ToString(min) + "\n" + "Revision : " + Convert.ToString(rev) + "\n" +"OS Driver Type : " +driverType,"GetVersion",MessageBoxButtons.OK,MessageBoxIcon.Information );			
				//clear all input box on API success		
				clearTextBox_succ("GetVersion");
				
			}
			else
			{
				// Diplay API failure messafe with API return code.				
				clearTextBox_fail("GetVersion",status);
				
			}				   
					
		}

		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure: GetHardLimit
		'*
		'* Purpose  : called on GetHardLimit button click
		'*
		' Descrip   :RNBOsproGetHardLimit
		'****************************************************************************/
		
		private void GetHardLmt_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;
			ushort hardLimit=0;
			
			//**************RNBOsproGetHardLimit API **********************/
			status = Superpro.RNBOsproGetHardLimit( Superpro.packet, out hardLimit );
			// if API successfull
			if (status==0)
			{	
				//clear all input box on API success		
				clearTextBox_succ("GetHardLimit");
				//display hardlimit value
				Output.Text = "HardLimit = "+Convert.ToString(hardLimit,10);
			}
			else
			{
				//clear output box
				Output.Text ="";
				// Diplay API failure messafe with API return code.				
				clearTextBox_fail("GetHardLimit",status);
				
			}				   


		}

		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure:StatusBtn_Click
		'*
		'* Purpose  : Called on GetFullStatus button click
		'*
		' Descrip   :RNBOsproGetFullStatus API call is here
		'****************************************************************************/

		private void StatusBtn_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;			
			
			//**************RNBOsproGetFullstatus API **********************/
			status=Superpro.RNBOsproGetFullStatus(Superpro.packet );
			//clear all input box
			CellNumber.Text = "";
			AccessCode.Text = "";
			Input.Text = "";
			Output.Text = "";
			StatusLine.Items.Clear();
			// display API success full message in status box
			StatusLine.Items.Add("GetFullStatus successful!");
			StatusLine.Items.Add("Status of last API called is "+status+".");
		}

		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/

		/**************************************************************************
		'* Procedure:KeyInfo_Click
		'*
		'* Purpose  : Called on KeyInfo button click
		'*
		' Descrip   :RNBOsproKeyInfo API call is here
		'****************************************************************************/
		private void KeyInfo_Click(object sender, System.EventArgs e)
		{	
			
			KeyInfo KeyInfoForm = new KeyInfo();
			//display key info form
			KeyInfoForm.ShowDialog();	
		}

		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure:GetSubLicBtn_Click
		'*
		'* Purpose  : Called on GetSubLicense button click
		'*
		' Descrip   :RNBOsproGetSubLicense API call is here
		'****************************************************************************/

		private void GetSubLicBtn_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;
			ushort cellAdd=0;
			int i_IsValid=-1;
			string scellAdd="";
			
			// Get Cell address value as string enterd by user
			scellAdd=CellNumber.Text;
			//Perform validation for CellAddress string value and convert into integer.
			i_IsValid = isValidData(scellAdd.Trim(), CELLADDRESS_LENGTH,ref cellAdd);
			if(i_IsValid==1)//if celladdress value is blank
			{
				MessageBox.Show("Specify Cell No. to proceed.","GetSubLicense",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==2)//if cell address string value length is invalid
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","GetSubLicense",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==3)//if celladdress string is in valid hex string
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","GetSubLicense",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			
			//**************RNBOsproGetSubLicense API **********************/
			status =  Superpro.RNBOsproGetSubLicense( Superpro.packet, cellAdd );
			// if API successfull
			if(status==0)
			{
				//clear all input box on API success		
				clearTextBox_succ("GetSubLicense");
			}
			else
			{
				// Diplay API failure messafe with API return code.				
				clearTextBox_fail("GetSubLicense",status);
			}
		}

		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure:ReleaseLicBtn_Click
		'*
		'* Purpose  : Called on ReleaseLicense button click
		'*
		' Descrip   :RNBOsproReleaseLicense API call is here
		'****************************************************************************/
		private void ReleaseLicBtn_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;
			ushort cellAdd=0;
			ushort numLic=0;
			int i_IsValid=-1;
			string scellAdd="";
			string snumLic="";
			
			// Get Cell address value as string enterd by user
			scellAdd=CellNumber.Text;
			//Perform validation for CellAddress string value and convert into integer.
			i_IsValid = isValidData(scellAdd.Trim(), CELLADDRESS_LENGTH,ref cellAdd);
			if(i_IsValid==1)//if celladdress value is blank
			{
				MessageBox.Show("Specify Cell No. to proceed.","ReleaseLicense",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==2)//if cell address string value length is invalid
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","ReleaseLicense",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==3)//if celladdress string is in valid hex string
			{
				MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.","ReleaseLicense",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			snumLic=Input.Text;
			if (snumLic.Trim()== "")//if NumLic value is blank 
			{
				MessageBox.Show("Specify numLic to proceed.","ReleaseLicense",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			
			try
			{
				//convert num lic value into integer
				numLic=Convert.ToUInt16(snumLic,10);
			}
			catch
			{
				// if numLic value is not valid integer string 
				MessageBox.Show("Number of sublicense to release must be an integer between 0 to 65535.","ReleaseLicense",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			
			if(( numLic < 0 || numLic >65535))//check for valid value of NumLic
			{
				MessageBox.Show("Number of sublicense to release must be an integer between 0 to 65535.","ReleaseLicense",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			
			//**************RNBOsproReleaseLicense API **********************/
			status=Superpro.RNBOsproReleaseLicense( Superpro.packet, cellAdd, ref numLic );
			// if API successfull
			if(status==0)
			{
				//clear all input box on API success		
				clearTextBox_succ("ReleaseLicense");
			}
			else
			{
				// Diplay API failure messafe with API return code.				
				clearTextBox_fail("ReleaseLicense",status);
			}
		}

		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure:EnumServerBtn_Click
		'*
		'* Purpose  : Called on EnumServer button click
		'*
		' Descrip   :RNBOsproEnumServer API call is here
		'****************************************************************************/
		private void EnumServer_Click(object sender, System.EventArgs e)
		{
			EnumServer EnumForm = new EnumServer();
			//display EnumServer Box
			EnumForm.ShowDialog();	
		}

		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure:KeyView_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
		'*
		'* Purpose  : Called on KeyView button click
		'*
		' Descrip   :This function is to show View of Key
		'****************************************************************************/
		private void ViewBtn_Click(object sender, System.EventArgs e)
		{
			ushort data=0;
			byte accessCode=0;
			ushort status = 0;
			uint a; // loop variable;
			uint b; // loop variable
			string gViewText=""; // string variable to display in keyview list box
			
			// Heading for key view
			string viewString = "    Adr    Data    AC   Adr    Data    AC   Adr    Data    AC   Adr    Data    AC      ";
			// some temparary string variable to make key view allign properly
			string space_pad1="";
			string space_pad2="";
			string space_pad3="";
			string space_pad4="";
			//clear  elements of List box
			ViewList.Items.Clear();	
			// add first element as heading of keyView list box
			ViewList.Items.Add(viewString);
			// formating for keyview
			viewString = "    ---    ----    --   ---    ----    --   ---    ----    --   ---    ----    --    ";
			ViewList.Items.Add(viewString);		
			// loop to display 16 rows in key view list box
			for ( a = 0; a < 16; a++ )
			{
				gViewText = "";
				
				// assingn blank to temp string variables used for allignment
				space_pad1="";
				space_pad2="";
				space_pad3="";
				space_pad4="";

				// loop to make 4 cell key data in each row of list box
				for ( b = 0; b < 4; b++ )
				{
					space_pad4="".PadLeft(4,' ');//For just allignment and formmating of key view
					space_pad1=Convert.ToString(a+16*b,16).PadLeft(2,'0');// calculate celladdress value in hex
					data = 0;
					accessCode = 0;
					// Call RNBOsproExtendedRead API to display key view
					status = Superpro.RNBOsproExtendedRead( Superpro.packet,(ushort)(a+16*b) , ref data, ref accessCode );
					// if API get successfull
					if ( status != 0 )
					{
						space_pad2="????".PadLeft(9,' ');//For just allignment and formmating of key view
						if ( status == 4 )// if API return code is 4 then
							space_pad3="3".PadLeft(5,' ');// display 3 as access code of cell data
						else
							space_pad3="?".PadLeft(5,' ');//else display unknown accessCode(?) 
						//concat one string to display one cell view
						gViewText=gViewText+space_pad4+space_pad1+space_pad2+space_pad3;
						
					}
					//If API succesfull
					else
					{               
						space_pad2=Convert.ToString(data,16).PadLeft(4,'0');// cell data
						space_pad3=Convert.ToString(accessCode,16).PadLeft(1,'0');//accesscode
						string space_pad5="".PadLeft(5,' ');//For just allignment and formmating of key view
						string space_pad6="".PadLeft(4,' ');//For just allignment and formmating of key view
						//concat one string to display one cell view
						gViewText=gViewText+space_pad4+space_pad1+space_pad5+space_pad2+space_pad6+space_pad3;
					}
				}
				gViewText.ToUpper();//convert into upercase
				// add row in ListBOX
				ViewList.Items.Add(gViewText.ToUpper());
			}

		}

		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure:PasswordBtn_Click
		'*
		'* Purpose  : Called on Password button click
		'*
		' Descrip   :This function is to Password dialog box to enter write and overwrite password of key
		'****************************************************************************/
		private void PasswordBtn_Click(object sender, System.EventArgs e)
		{
			//display password form to seek key passwords form user
			Password PasswordForm = new Password();
			PasswordForm.ShowDialog();	
		}

		/**************************************************************************
		'* Procedure:ExitBtn_Click
		'*
		'* Purpose  : Called on Exit button click
		'*
		' Descrip   :This function is to call releaseLicense API at the time of application exit
		'****************************************************************************/
		
		private void ExitBtn_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;			
			ushort numOfLicense = 0;
			// call RNBOsproReleaseLicense API to release all the license issued for this client
			status=Superpro.RNBOsproReleaseLicense( Superpro.packet, 0x0, ref numOfLicense );
			Close ();//close main form
		}

		/**************************************************************************
		'* Procedure: InitializeBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
		'*
		'* Purpose  : called on Initialize button click
		'*
		' Descrip   :RNBOsproInitialize API call is here
		'****************************************************************************/
		private void button3_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;			
			
			//**************RNBOsproInitialize API **********************/
			status= Superpro.RNBOsproInitialize( Superpro.packet );
			//if API get successfull
			if (status==0)
			{
				//clear all input box on API success
				clearTextBox_succ("Initialize");
			}
			else
			{
				//display API failure message with return code of API
				clearTextBox_fail("Initialize",status);
			}
		}
		
		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure:isValidData(ByRef thisString As String, ByVal length As Integer, ByRef OutData As Int32) As Int16
		'*
		'* Purpose  : This will call to validate different user inputs.
		'*
		'  Descrip   : THis is used to to check valid hex string and valid length of inputs.
		'****************************************************************************/
		public static int isValidData(string thisString, ushort length,ref ushort OutData) 
		{
			
			if (thisString.Length <=0)
			// if string blank then retun 1
				return 1;
			if (thisString.Length >length)
				// if string length is invalid then return 2
				return 2;
			if (readHexData(thisString,ref OutData)==-1) 
				// string is not valid hex string then return 3
				return 3;
			//if data is valid then return 0
			return 0;

		}
		
		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/

		/**************************************************************************
		'* Procedure:readHexData(string thisString,ref uint OutData) 
		'*
		'* Purpose  : This will call to convert hexstring into integer value
		'****************************************************************************/
		public static int readHexData(string thisString,ref ushort OutData) 
		{
			
			int i = 0;
		
			char[] singleChar=new char[1];
			//loop for all character in string
			while (i < thisString.Length) 
			{
				singleChar=thisString.ToCharArray(i,1);
				
				// check for valid hex character
				if ((((int)singleChar[0] < '0') ||((int)singleChar[0] > '9'))&&(((int)singleChar[0] < 'A')||((int)singleChar[0] > 'F')&&((int)singleChar[0] < 'a')||((int)singleChar[0] > 'f')))
					// if not a valid hex character then rerurn -1
					return -1;
				i++;

				
			}
			// if valid hex string then convert into integer
			try
			{
				OutData=Convert.ToUInt16(thisString,16);
			}
			catch
			{
				// if exception occured then return -1
				return -1;
			}
			//if valid hex data then return 0	
			return 0;
		}
		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure:isValidQueryData(ByRef input As String) As Int16
		'*
		'* Purpose  : perform some validation on qyery data
		'****************************************************************************/
		public static int isValidQueryData( string input) 
		{
			string thisString;
			int stringLength;
			thisString = input.ToUpper();
			stringLength = thisString.Length;
			int i = 0;
			
			if (thisString.Length <=0)// check for blank querydata string
				return 1;
			//check for even length query data
			if (thisString.Length >(Superpro.SPRO_MAX_QUERY_SIZE *2) ||thisString.Length <MINIMUM_QUERYDATA_LENGTH ||((thisString.Length %2)!=0))
				return 2;
			
			char[] singleChar=new char[1];
			// check for valid hex string
			while (i < thisString.Length) 
			{
				singleChar=thisString.ToCharArray(i,1);
				
				if ((((int)singleChar[0] < '0') ||((int)singleChar[0] > '9'))&&(((int)singleChar[0] < 'A')||((int)singleChar[0] > 'F')&&((int)singleChar[0] < 'a')||((int)singleChar[0] > 'f')))
					// if not a vallid hex character then return 3
					return 3;
				i++;
			}
			
			//if valid querydata then return 0
			return 0;
		}
		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure:isValidQueryData(ByRef input As String) As Int16
		'*
		'* Purpose  : Convert input query data in byte
		'****************************************************************************/

		static byte[] ConvertQueryData(string input) 
		{
			int i = 0,j=0;
			char[] singleChar=new char[1];//character variable
			char[] singleChar1=new char[1];//character variable
			byte[] queryBuffer = new byte[input.Length/2];//buffur for querydata
			string thisString;
			int stringLength;
			int hiByte, loByte;
			thisString = input.ToUpper();//convert query string into upercase
			stringLength = thisString.Length;
			
			//here we will convert query string into array of length /2 of byte
			for (i = 0; i < thisString.Length; i+= 2) 
			{
				//get ith character from input query string
				singleChar=thisString.ToCharArray(i,1);
				//get ith +1 character from input query string
				singleChar1=thisString.ToCharArray(i+1,1);
				//convert ith character into there aschi value
				if ((singleChar[0] >= '0') && (singleChar[0] <= '9'))
					hiByte = (int)(singleChar[0] - 48) * 16;
				else
					hiByte = (int)(singleChar[0] - 55) * 16;

				if ((singleChar1[0] >= '0') && (singleChar1[0] <= '9'))
					loByte = (int)singleChar1[0] - 48;
				else
					loByte = (int)singleChar1[0] - 55;
				//add ascii value of ith and ith+1 character and assign to jth element of 
				//array of length/2 of byte data type
				queryBuffer[j]=(byte)(hiByte + loByte);
				j++;//increment j by 1
			}
			return queryBuffer;//return array of byte
		}
		
		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure:ConvertResponse(byte[] charString) 
		'*
		'* Purpose  : Convert query response in readable char
		'****************************************************************************/

		static string ConvertResponse(byte[] charString) 
		{
			StringBuilder hexValueBuffer = new StringBuilder();
			StringBuilder RevhexValueBuffer = new StringBuilder();
			int i;

			//convert query response to hex string
			for (i = 0; i < charString.Length; i++)
				hexValueBuffer.Append(IntToHex(charString[i], 2));

			// For reversing 
			for (int j=0 ;j<hexValueBuffer.Length;j+=2)
			{
				RevhexValueBuffer.Append(hexValueBuffer[j+1]);
				RevhexValueBuffer.Append(hexValueBuffer[j]);
			}

			return RevhexValueBuffer.ToString();
		}

		
		/***** convert int to ascii char**************/
		static string IntToHex(int decValue, int length) 
		{
			StringBuilder hexValueBuffer = new StringBuilder();
			char hexChar;
			int quotient = decValue;
			int remainder;
			int count = 0;
// convert response into double length hex string to display valid hex query response for user
			while ((quotient > 0) || (count < length)) 
			{
				remainder = quotient % 16;
				if (remainder <= 9)
					hexChar = (char)(remainder + 48);
				else
					hexChar = (char)(remainder + 55);

				hexValueBuffer.Append(hexChar);
				quotient /= 16;
				count ++;
			}

			return (hexValueBuffer.ToString());
		}/*end of InttoHex fn*/

		
		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		* 		'* Procedure:InitialView()
		'*
		'* Purpose  : Display key view on form load time**************
		'****************************************************************************/

		public void InitialView()
		{
			
			uint a;// loop variable;
			uint b;// loop variable;
			string gViewText="";// string variable to display in keyview list box
			// Heading for key view
			string viewString = "    Adr    Data    AC   Adr    Data    AC   Adr    Data    AC   Adr    Data    AC      ";
			// some temparary string variable to make key view allign properly
			string space_pad1="";
			string space_pad2="";
			string space_pad3="";
			string space_pad4="";
			//clear  elements of List box
				
			ViewList.Items.Clear();	
			// add first element as heading of keyView list box
			ViewList.Items.Add(viewString);
			// formating for keyview
			viewString = "    ---    ----    --   ---    ----    --   ---    ----    --   ---    ----    --    ";
			ViewList.Items.Add(viewString);		
			// loop to make 4 cell key data in each row of list box
			for ( a = 0; a < 16; a++ )
			{
				gViewText = "";
				//gString   = "";
				space_pad1="";
				space_pad2="";
				space_pad3="";
				space_pad4="";
				// loop to make 4 cell key data in each row of list box
				for ( b = 0; b < 4; b++ )
				{
					
					space_pad4="".PadLeft(4,' ');
					space_pad1=Convert.ToString(a+16*b,16).PadLeft(2,'0');
					space_pad2="????".PadLeft(9,' ');//For just allignment and formmating of key view
					space_pad3="?".PadLeft(5,' ');//For just allignment and formmating of key view
					//concat one string to display one cell view
					gViewText=gViewText+space_pad4+space_pad1+space_pad2+space_pad3;
				}
				gViewText.ToUpper();//convert into upercase
				// add row in ListBOX
				ViewList.Items.Add(gViewText.ToUpper());
			}
		}

		
		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure:clearTextBox_succ(string API)
		'*
		'* Purpose  : This will call when API get success.
		'*
		'  Descrip   : THis is used to clear diff. input box when API get success.
		'****************************************************************************/
		public void clearTextBox_succ(string API)
		{
			// clear diffrent on success of API
			if (API.Equals("FormatPacket")||API.Equals("Initialize")||API.Equals("SetContactServer")||API.Equals("SetProtocol")||
				API.Equals("FindFirstUnit")||API.Equals("FindNextUnit")||API.Equals("SetHeartBeat")||API.Equals("Write")||
				API.Equals("Overwrite")||API.Equals("Activate")||API.Equals("Decrement")||API.Equals("GetVersion")||
				API.Equals("GetSubLicense")||API.Equals("ReleaseLicense"))
			{

				CellNumber.Text = "";
				AccessCode.Text = "";
				Input.Text = "";
				Output.Text ="";

				StatusLine.Items.Clear();
				StatusLine.Items.Add(API + " successful!");
			}
			if (API.Equals("Read")||API.Equals("GetHardLimit")||API.Equals("GetContactServer")||
				API.Equals("Query"))
			{

				CellNumber.Text = "";
				AccessCode.Text = "";
				Input.Text = "";
				StatusLine.Items.Clear();
				StatusLine.Items.Add(API + " successful!");
			}
			if (API.Equals("ExtendedRead"))
			{

				CellNumber.Text = "";
				Input.Text = "";
				StatusLine.Items.Clear();
				StatusLine.Items.Add(API + " successful!");
			}
		}

		
		/**************************************************************************
		' END OF FUNCTION
		'****************************************************************************/
		/**************************************************************************
		'* Procedure:clearTextBox_fail(string API,uint retCode)
		'*
		'* Purpose  : This will call when API get fail
		'*
		'  Descrip   : THis is used to display API return code when API failed.
		'****************************************************************************/
		public void clearTextBox_fail(string API,uint retCode)
		{
				//display API failure message with API return code
				StatusLine.Items.Clear();
				StatusLine.Items.Add(API+" failed!");
				StatusLine.Items.Add("Return code is "+ retCode +".");
			
		}

		
	

	}
		 

}
